# A job to build and publish containers to project registries.
#
# - Does NOT depend on Alexlab Cloud build containers
# - DOES use BusyBox (https://www.busybox.net), included with the Docker
#   "Official Image": https://github.com/docker-library/docker

spec:
  inputs:
    'package_dir':
      default: 'packages'
    'docker_tag':
      default: '27.1.1'
---

include:
  - component: gitlab.com/alexlab-cloud/infra/ci/lib/common/bootstrap.gitlab-ci@main

'job:publish-container-images':
  image: docker:$[[ inputs.docker_tag ]]
  before_script:
    - apk add coreutils jq
  services:
    - name: docker:$[[ inputs.docker_tag ]]-dind
      alias: docker
  extends:
    - '.base-stage:publish'
  variables:
    DOCKER_HOST: tcp://docker:2376
    DOCKER_TLS_VERIFY: '1'
    DOCKER_TLS_CERTDIR: '/certs'
    DOCKER_CERT_PATH: '/certs/client'
    DOCKER_DRIVER: overlay2
  script:
    # Iterate over every folder and subfolder in the packages root that contains a package.json file
    # NOTE: The `find` command is slightly different in BusyBox vs. most GNU/Linux environments 
    - >
      for PKG_PATH in $(find $[[ inputs.package_dir ]]/** -type d -exec test -f {}/package.json \; -print); do
          PKG_NAME=$(basename $PKG_PATH)
          VER_TAG=$(jq -r '.version' $PKG_PATH/package.json)
          REGISTRY_IMAGE_PATH=$CI_REGISTRY/$CI_PROJECT_PATH/$PKG_NAME

          # Use the package source to build a Docker image and push it to its project's container registry
          # Include a specific package version tag and "latest"
          docker build -t $REGISTRY_IMAGE_PATH:$VER_TAG -t $REGISTRY_IMAGE_PATH:latest -f ./$PKG_PATH/Dockerfile.$PKG_NAME .

          # Log in to the project's registry and push both images
          docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
          docker push $REGISTRY_IMAGE_PATH:$VER_TAG
          docker push $REGISTRY_IMAGE_PATH:latest
      done
    